/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.DataMapObjekModulToKelompokUserDto;
import com.portofolio.service.MapObjekModulToKelompokUserService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;

@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/mapObjekModulToKelompokUser")
public class MapObjekModulToKelompokUserController extends LocaleController {
	@Lazy
	@Autowired
	private MapObjekModulToKelompokUserService mapObjekModulToKelompokUserService;


	
	@ApiOperation("Api Untuk Update MapObjekModulToKelompokUser")
	@PutMapping("/saveOrUpdate")
	public ResponseEntity<Map<String, Object>> update(@Valid @RequestBody DataMapObjekModulToKelompokUserDto entity) {
		Map<String, Object> result = mapObjekModulToKelompokUserService.saveOrUpdate(entity);
		return RestUtil.getJsonResponse(result);
	}


	
	@ApiOperation("Api Untuk Menampilkan Semua MapObjekModulToKelompokUser")
	@GetMapping("/grid")
	public ResponseEntity<Map<String, Object>> grid(@RequestParam(value = "page", defaultValue = "1") Integer page,
			@RequestParam(value = "rows", defaultValue = "300") Integer rows,
			@RequestParam(value = "dir", defaultValue = "id.kdKelompokUser") String dir,
			@RequestParam(value = "sort", defaultValue = "desc") String sort,
			@RequestParam(value = "kdKelompokUser", required = false) Integer kdKelompokUser) {
		Map<String, Object> result = mapObjekModulToKelompokUserService.grid(page, rows, sort, dir, kdKelompokUser);
		return RestUtil.getJsonResponse(result);
	}

	

	
	@ApiOperation("Api Untuk Menampilkan tree ModulAndObjekModulAplikasi")
	@GetMapping("/findMapObjModTree")
	public ResponseEntity<Map<String, Object>> findMapObjModTree(
			@RequestParam(value = "kdKelompokUser") Integer kdKelompokUser,
			@RequestParam(value = "kdModulAplikasi") String kdModulAplikasi,
			@RequestParam(value = "kdVersion") Integer kdVersion,
			HttpServletRequest request) {
		Map<String, Object> result = mapObjekModulToKelompokUserService.findModulAndObjekModulAplikasiTree(kdKelompokUser,kdModulAplikasi,kdVersion);
		return RestUtil.getJsonResponse(result);
	}

}
